<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/29/2003 *
 * ===============                              Last change: 11/11/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : install-inc.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Functions for installation procedure             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die Installationsroutine         *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

/************************************************************************
 *      YOU MAY ALSO WANT TO REMOVE THIS FILE AFTER INSTALLTION!        *
 ************************************************************************/

// Some security stuff...
if (ereg(basename(__FILE__), $_SERVER['PHP_SELF'])) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

//
function install_WriteData ($file, $comment, $prefix, $suffix, $DATA, $sneak=0) {
	// Initialize all and count up the "seak" value
	$done = false;
	$next = 0;
	$sneak++;
	if ((file_exists($file)) && (is_readable($file))) {
		$search = "CFG: ".$comment;
		$tmp = $file.".tmp";
		$fp = @fopen($file, 'r') or OUTPUT_HTML("<STRONG>READ:</STRONG> ".$file."<br />");
		if (is_resource($fp)) {
			$fp_tmp = @fopen($tmp, 'w') or OUTPUT_HTML("<STRONG>WRITE:</STRONG> ".$tmp."<br />");
			if (is_resource($fp_tmp)) {
				while (!feof($fp)) {
					$line = fgets ($fp, 10240);
					if (strpos($line, $search) > -1) $next = 0;
					if ($next > -1) {
						if ($next == $sneak) {
							$next = -1;
							$line = $prefix.$DATA.$suffix."\n";
						} else {
							$next++;
						}
					}
					fputs($fp_tmp, $line);
				}
				fclose($fp_tmp);

				// Finished writing tmp file
				$done = true;
			}

			// Close source directory
			fclose($fp);

			if (($done) && (is_writeable($file))) {
				// Copy back tmp file and delete tmp :-)
				@copy($tmp, $file);
				@unlink($tmp);
			} else {
				OUTPUT_HTML("<STRONG>TMP:</STRONG> UNDONE!");
			}
		}
	} else {
		OUTPUT_HTML("<STRONG>404:</STRONG> ".$file."<br />");
	}
}

//
$mysql = "";
if (isset($_POST['mysql']) && is_array($_POST['mysql'])) $mysql = $_POST['mysql'];

if (URL != "http://your-server.com") {
	// Already installed???
	$burl = URL;
} elseif ($burl == "") {
	// Auto-detect URL
	$burl = "http://".$SERVER_NAME.$_SERVER['PHP_SELF'];
	$burl = substr($burl, 0, strpos($burl, "install.php"));
}

// Check if both passwords from SMTP are matching
if ((isset($_GET['page']) && ($_GET['page'] == 5))) {
	// Okay, we have to check it
	if (!empty($_POST['smtp_user']) && (empty($_POST['smtp_host']))) {
		// Hostname not set
		OUTPUT_HTML(INSTALL_SMTP_HOSTNAME_EMPTY."<br />");
		$_GET['page'] = 3;
	}
	if ((empty($_POST['smtp_pass1'])) && (!empty($_POST['smtp_pass2']))) {
		// Password is empty
		OUTPUT_HTML(INSTALL_SMTP_PASS1_EMPTY."<br />");
		$_GET['page'] = 3;
	}
	if ((!empty($_POST['smtp_pass1'])) && (empty($_POST['smtp_pass2']))) {
		// Password repeat is empty
		OUTPUT_HTML(INSTALL_SMTP_PASS2_EMPTY."<br />");
		$_GET['page'] = 3;
	}
	if ($_POST['smtp_pass1'] != $_POST['smtp_pass1']) {
		// Passwords are not matching
		OUTPUT_HTML(INSTALL_SMTP_PASS_MISMATCH."<br />");
		$_GET['page'] = 3;
	}
}

// Is MXChange installed or no admin registered so far?
if ((!isBooleanConstantAndTrue('mxchange_installed')) || (!isBooleanConstantAndTrue('admin_registered')))
{
	// Set URL for FORM actions
	define('__BURL_ACTION', $burl);

	// Output page for entered value
	switch ($_GET['page'])
	{
	case "welcome": // Welcome to the installation!
		LOAD_TEMPLATE("install_welcome");
		break;

	case "1": // Server path, base URL
		define('__PATH_LEN'     , strlen(PATH));
		define('__BURL_LEN'     , strlen($burl));
		define('__TITLE_LEN'    , strlen(MAIN_TITLE));
		define('__SLOGAN_LEN'   , strlen(SLOGAN));
		define('__WEBMASTER_LEN', (strlen(WEBMASTER) * 3));

		// Load template
		LOAD_TEMPLATE("install_page1");
		break;

	case "2": // MySQL data (alone!)
		if (empty($mysql['dbase']))  $mysql['dbase']  = "your_database";
		if (empty($mysql['login']))  $mysql['login']  = "your_login";
		if (empty($mysql['host']))   $mysql['host']   = "localhost";
		if (empty($mysql['prefix'])) $mysql['prefix'] = "mxchange_";
		if ((sizeof($FATAL) > 0) || (!empty($FATAL[0]))) {
			OUTPUT_HTML("<SPAN class=\"install_fatal\">");
			foreach ($FATAL as $key=>$err) {
				OUTPUT_HTML("  <STRONG>&middot;</STRONG>&nbsp;".FATAL_NO.($key + 1).":&nbsp;".$err."<br />");
			}
			OUTPUT_HTML("</SPAN><br />");
		}
		define('__MYSQL_HOST'  , $mysql['host']);
		define('__MYSQL_DBASE' , $mysql['dbase']);
		define('__MYSQL_PREFIX', $mysql['prefix']);
		define('__MYSQL_LOGIN' , $mysql['login']);
		define('__SPATH_VALUE' , $_POST['spath']);
		define('__BURL_VALUE'  , $_POST['burl']);
		define('__TITLE_VALUE' , $_POST['title']);
		define('__SLOGAN_VALUE', $_POST['slogan']);
		define('__EMAIL_VALUE' , $_POST['email']);

		// Load template
		LOAD_TEMPLATE("install_page2");
		break;

	case "3":
		// Set more values
		define('__SPATH_VALUE'	, $_POST['spath']);
		define('__BURL_VALUE'	, $_POST['burl']);
		define('__TITLE_VALUE'	, $_POST['title']);
		define('__SLOGAN_VALUE'	, $_POST['slogan']);
		define('__EMAIL_VALUE'	, $_POST['email']);

		// Use default SMTP data
		$smtpHost  = SMTP_HOSTNAME;
		$smtpUser  = SMTP_USER;
		$smtpPass1 = SMTP_PASSWORD;
		$smtpPass2 = SMTP_PASSWORD;

		// Overwrite it with the data from sent (failed) form
		if (!empty($_POST['smtp_host'])) $smtpHost = $_POST['smtp_host'];
		if (!empty($_POST['smtp_user'])) $smtpUser = $_POST['smtp_user'];

		// MySQL settings
		define('__MYSQL_HOST'	, $mysql['host']);
		define('__MYSQL_DBASE'	, $mysql['dbase']);
		define('__MYSQL_PREFIX'	, $mysql['prefix']);
		define('__MYSQL_LOGIN'	, $mysql['login']);
		define('__MYSQL_PASS1'	, $mysql['pass1']);
		define('__MYSQL_PASS2'	, $mysql['pass2']);

		// Set constants for SMTP data
		define('__SMTP_HOST'	, $smtpHost);
		define('__SMTP_USER'	, $smtpUser);
		define('__SMTP_PASS1'	, $smtpPass1);
		define('__SMTP_PASS2'	, $smtpPass2);

		// Load template
		LOAD_TEMPLATE("install_page3");
		break;

	case "5": // Misc settings
		// General settings
		define('__SPATH_VALUE'	, $_POST['spath']);
		define('__BURL_VALUE'	, $_POST['burl']);
		define('__TITLE_VALUE'	, $_POST['title']);
		define('__SLOGAN_VALUE'	, $_POST['slogan']);
		define('__EMAIL_VALUE'	, $_POST['email']);

		// MySQL settings
		define('__MYSQL_HOST'	, $mysql['host']);
		define('__MYSQL_DBASE'	, $mysql['dbase']);
		define('__MYSQL_PREFIX'	, $mysql['prefix']);
		define('__MYSQL_LOGIN'	, $mysql['login']);

		// SMTP settings
		define('__SMTP_HOST'	, $_POST['smtp_host']);
		define('__SMTP_USER'	, $_POST['smtp_user']);
		define('__SMTP_PASS'	, $_POST['smtp_pass1']);
		OUTPUT_HTML("<FORM action=\"".__BURL_ACTION."/install.php?page=finalize\" method=\"POST\" target=\"_self\">
<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"install_content\">
<TR>
  <TD colspan=\"2\" align=\"center\">
    <STRONG class=\"install\">".HEADER_TEXT_PAGE5."</STRONG>
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD colspan=\"2\"><SPAN class=\"install_intro\">
    ".TEXT_PAGE_5."
  </SPAN></TD>
</TR>
<TR><TD colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD class=\"install\" align=\"right\">".LANG_OUTPUT_MODE.":&nbsp;&nbsp;</TD>
  <TD>
    <SELECT name=\"omode\" size=\"1\" class=\"install_select\">
      <OPTION value=\"render\"");
		if (OUTPUT_MODE == "render") OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".MODE_RENDER."</OPTION>
      <OPTION value=\"direct\"");
		if (OUTPUT_MODE == "direct") OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".MODE_DIRECT."</OPTION>
    </SELECT>
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"10\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD class=\"install\" align=\"right\">".WARN_NO_PASSWORD.":&nbsp;&nbsp;</TD>
  <TD>
    <SELECT name=\"warn_no_pass\" size=\"1\" class=\"install_select\">
      <OPTION value=\"true\"");
		if (warn_no_pass) OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".YES."</OPTION>
      <OPTION value=\"false\"");
		if (!warn_no_pass) OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".NO."</OPTION>
    </SELECT>
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"10\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD class=\"install\" align=\"right\">".LANG_WRITE_FOOTER.":&nbsp;&nbsp;</TD>
  <TD>
    <SELECT name=\"wfooter\" size=\"1\" class=\"install_select\">
      <OPTION value=\"true\"");
		if (WRITE_FOOTER) OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".YES."</OPTION>
      <OPTION value=\"false\"");
		if (!WRITE_FOOTER) OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".NO."</OPTION>
    </SELECT>
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"10\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD class=\"install\" align=\"right\">".INSTALL_ENABLE_BACKLINK.":&nbsp;&nbsp;</TD>
  <TD>
    <SELECT name=\"blink\" size=\"1\" class=\"install_select\">
      <OPTION value=\"true\"");
		if (ENABLE_BACKLINK) OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".YES."</OPTION>
      <OPTION value=\"false\"");
		if (!ENABLE_BACKLINK) OUTPUT_HTML(" selected=\"selected\"");
		OUTPUT_HTML(">".NO."</OPTION>
    </SELECT>
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD colspan=\"2\" align=\"center\">");
		foreach ($mysql as $key=>$value) {
			OUTPUT_HTML("    <INPUT type=\"hidden\" name=\"mysql[".$key."]\" value=\"".$value."\">");
		}
		OUTPUT_HTML("    <INPUT type=\"hidden\" name=\"spath\" value=\"".__SPATH_VALUE."\">
    <INPUT type=\"hidden\" name=\"burl\" value=\"".__BURL_VALUE."\">
    <INPUT type=\"hidden\" name=\"title\" value=\"".__TITLE_VALUE."\">
    <INPUT type=\"hidden\" name=\"slogan\" value=\"".__SLOGAN_VALUE."\">
    <INPUT type=\"hidden\" name=\"email\" value=\"".__EMAIL_VALUE."\">
    <INPUT type=\"hidden\" name=\"smtp_host\" value=\"".__SMTP_HOST."\">
    <INPUT type=\"hidden\" name=\"smtp_user\" value=\"".__SMTP_USER."\">
    <INPUT type=\"hidden\" name=\"smtp_pass\" value=\"".__SMTP_PASS."\">
    <INPUT type=\"submit\" class=\"admin_submit submit\" name=\"finalize\" value=\"".NEXT_PAGE."\" class=\"install_submit\">
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</TD></TR>
</TABLE>
</FORM>");
		break;

	case "finalize": // Write captured data to files
		if ((!empty($_POST['finalize'])) && (!isBooleanConstantAndTrue('mxchange_installed'))) {
			// You have submitted data then we have to reset the fatal messages
			$FATAL = array(); $SQLs = array();

			// Connect to MySQL server
			$link = SQL_CONNECT($mysql['host'], $mysql['login'], $mysql['pass1'], __FILE__, __LINE__);
			if ($link) {
				// Seems to work, also right database?
				$db = SQL_SELECT_DB($mysql['dbase'], $link, __FILE__, __LINE__);
				if ($db) {
					// Automatically run install.sql
					if ((file_exists($_POST['spath']."install/tables.sql")) && (file_exists($_POST['spath']."install/menu-".GET_LANGUAGE().".sql"))) {
						// Both exists so import them
						foreach (array("tables.sql", "menu-".GET_LANGUAGE().".sql") as $dump) {
							// Should be save here because file_exists() is there but we check it again. :)
							$file = secureString($_POST['spath']) . "install/" . $dump;
							if ((file_exists($file)) && (is_readable($file))) {
								// Load the file
								$sql = implode("", file($file));

								// Remove some unwanted chars
								$sql = str_replace("\r", "", $sql);
								$sql = str_replace("\n\n", "\n", $sql);

								// And split it up against ;\n ...
								$SQLs = array_merge($SQLs, explode(";\n", $sql));
							}
						}

						// Are some SQLs found?
						if (count($SQLs) == 0) {
							// Abort here
							ADD_FATAL(INSTALL_SQL_IMPORT_FAILED);
							return;
						}

						// Now run all queries through and try to keep out empty or comment queries
						foreach ($SQLs as $sql) {
							// Trim spaces away
							$sql = trim($sql);

							// Is this query not empty and not a comment?
							if ((!empty($sql)) && (substr($sql, 0, 2) != "--") && (substr($sql, 0, 1) != "#")) {
								// Then run it!
								SQL_QUERY($sql, __FILE__, __LINE__);
							}
						}

						// Ok, all done. So we can write the config data to the php files
						if ($_POST['spath'] != PATH) install_WriteData($_POST['spath']."inc/config.php", "SERVER-PATH", "define ('PATH', \"", "\");", $_POST['spath'], 0);
						if ($_POST['burl']  != URL)  install_WriteData($_POST['spath']."inc/config.php", "HOST-URL", "define ('URL', \"", "\");", $_POST['burl'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "MAIN_TITLE", "define ('MAIN_TITLE', \"", "\");", $_POST['title'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "SLOGAN", "define ('SLOGAN', \"", "\");", $_POST['slogan'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "WEBMASTER", "define ('WEBMASTER', \"", "\");", $_POST['email'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "NULLPASS-WARNING", "define ('warn_no_pass', ", ");", $_POST['warn_no_pass'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "WRITE-FOOTER", "define ('WRITE_FOOTER', ", ");", $_POST['wfooter'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "BACKLINK", "define ('ENABLE_BACKLINK', ", ");", $_POST['blink'], 0);
						// install_WriteData($_POST['spath']."inc/config.php", "OUTPUT-MODE", "define ('OUTPUT_MODE', \"", "\");", $_POST['omode'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "MYSQL-HOST", "	'host'     => \"", "\",", $mysql['host'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "MYSQL-DBASE", "	'dbase'    => \"", "\",", $mysql['dbase'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "MYSQL-LOGIN", "	'login'    => \"", "\",", $mysql['login'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "MYSQL-PASSWORD", "	'password' => \"", "\",", $mysql['pass1'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "MYSQL-PREFIX", "define ('_MYSQL_PREFIX', \"", "\");", $mysql['prefix'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "SMTP-HOSTNAME", "define ('SMTP_HOSTNAME', \"", "\");", $_POST['smtp_host'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "SMTP-USER", "define ('SMTP_USER', \"", "\");", $_POST['smtp_user'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "SMTP-PASSWORD", "define ('SMTP_PASSWORD', \"", "\");", $_POST['smtp_pass'], 0);
						install_WriteData($_POST['spath']."inc/config.php", "INSTALLED", "define ('mxchange_installed', ", ");", "true", 0);

						// Close the link
						SQL_CLOSE($link, __FILE__, __LINE__);
					}
					 else
					{
						// Installation area not found!
						ADD_FATAL(INSTALL_MISSING_DUMPS);
					}
				}
			}
			if ((sizeof($FATAL) > 0) || ($FATAL[0] != ""))
			{
				$OUT = "";
	  			foreach ($FATAL as $value)
				{
					$OUT .= "    <LI>".$value."</LI>\n";
				}
				define('__FATAL_ERROR_LI', $OUT);
				$OUT = "";
				foreach ($mysql as $key=>$value)
				{
					$OUT .= "    <INPUT type=\"hidden\" name=\"mysql[".$key."]\" value=\"".$value."\">\n";
				}
				define('__MYSQL_DATA'	, $OUT);
				define('__SPATH_VALUE'	, $_POST['spath']);
				define('__BURL_VALUE'	, $_POST['burl']);
				define('__TITLE_VALUE'	, $_POST['title']);
				define('__SMTP_HOST'	, $_POST['smtp_host']);
				define('__SMTP_USER'	, $_POST['smtp_user']);
				define('__SMTP_PASS'	, $_POST['smtp_pass']);

				OUTPUT_HTML("<FORM action=\"".__BURL_ACTION."/install.php?page=2\" method=\"POST\">
<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"0\" class=\"install_content\">
<TR>
  <TD align=\"center\">
    <STRONG class=\"install\">".HEADER_MYSQL_ERRORS."</STRONG>
  </TD>
</TR>
<TR><TD colspan=\"2\" height=\"21\" class=\"seperator\">&nbsp;</TD></TR>
<TR>
  <TD><SPAN class=\"install_intro\">
    ".TEXT_MYSQL_ERRORS."
  </SPAN></TD>
</TR>
<TR>
  <TD align=\"center\"><STRONG>
    <OL>
".__FATAL_ERROR_LI."
    </OL>
".__MYSQL_DATA."
    <INPUT type=\"hidden\" name=\"spath\" value=\"".__SPATH_VALUE."\">
    <INPUT type=\"hidden\" name=\"burl\" value=\"".__BURL_VALUE."\">
    <INPUT type=\"hidden\" name=\"title\" value=\"".__TITLE_VALUE."\">
    <INPUT type=\"submit\" class=\"admin_submit\" name=\"ok\" value=\"".RETURN_MYSQL_PAGE."\">
  </STRONG></TD>
</TR>
</TABLE>
</FORM>");
			}
			 else
			{
				// Installation is done!
				$URL = $burl."/install.php?page=finalize";
				LOAD_URL($URL);
			}
		}
		 elseif (isBooleanConstantAndTrue('mxchange_installed'))
		{
			// Redirection after writing data... :-)
			LOAD_TEMPLATE("install_finished");
		}
		 else
		{
			// Something goes wrong during installation! :-(
			ADD_FATAL(INSTALL_FINALIZER_FAILED);
			include ("inc/fatal_errors.php");
		}
		break;

	default:
		OUTPUT_HTML("    <STRONG class=\"install_error\">".WRONG_PAGE."</STRONG>");
		break;
	}
}
 else
{
	ADD_FATAL(ALREADY_INSTALLED);
}
//
?>
